# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'ChunkConfigArgs',
    'ClusterConfigArgs',
    'ConnectionConfigArgs',
    'ConnectionArgs',
    'DiskConfigArgs',
    'DiskSpecArgs',
    'DiskArgs',
    'NodeConfigArgs',
    'PartitionConfigArgs',
    'SSDArgs',
]

@pulumi.input_type
class ChunkConfigArgs:
    def __init__(__self__, *,
                 coding: pulumi.Input[int],
                 data: pulumi.Input[int]):
        pulumi.set(__self__, "coding", coding)
        pulumi.set(__self__, "data", data)

    @property
    @pulumi.getter
    def coding(self) -> pulumi.Input[int]:
        return pulumi.get(self, "coding")

    @coding.setter
    def coding(self, value: pulumi.Input[int]):
        pulumi.set(self, "coding", value)

    @property
    @pulumi.getter
    def data(self) -> pulumi.Input[int]:
        return pulumi.get(self, "data")

    @data.setter
    def data(self, value: pulumi.Input[int]):
        pulumi.set(self, "data", value)


@pulumi.input_type
class ClusterConfigArgs:
    def __init__(__self__, *,
                 name: pulumi.Input[str],
                 chunks: Optional[pulumi.Input['ChunkConfigArgs']] = None,
                 device_class: Optional[pulumi.Input[str]] = None,
                 replicas: Optional[pulumi.Input[int]] = None):
        pulumi.set(__self__, "name", name)
        if chunks is not None:
            pulumi.set(__self__, "chunks", chunks)
        if device_class is not None:
            pulumi.set(__self__, "device_class", device_class)
        if replicas is not None:
            pulumi.set(__self__, "replicas", replicas)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def chunks(self) -> Optional[pulumi.Input['ChunkConfigArgs']]:
        return pulumi.get(self, "chunks")

    @chunks.setter
    def chunks(self, value: Optional[pulumi.Input['ChunkConfigArgs']]):
        pulumi.set(self, "chunks", value)

    @property
    @pulumi.getter(name="deviceClass")
    def device_class(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "device_class")

    @device_class.setter
    def device_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device_class", value)

    @property
    @pulumi.getter
    def replicas(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "replicas")

    @replicas.setter
    def replicas(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "replicas", value)


@pulumi.input_type
class ConnectionConfigArgs:
    def __init__(__self__, *,
                 host: pulumi.Input[str],
                 private_key_path: pulumi.Input[str],
                 port: Optional[pulumi.Input[int]] = None,
                 private_key_pass: Optional[pulumi.Input[str]] = None,
                 user: Optional[pulumi.Input[str]] = None):
        pulumi.set(__self__, "host", host)
        pulumi.set(__self__, "private_key_path", private_key_path)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if private_key_pass is not None:
            pulumi.set(__self__, "private_key_pass", private_key_pass)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def host(self) -> pulumi.Input[str]:
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: pulumi.Input[str]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter(name="privateKeyPath")
    def private_key_path(self) -> pulumi.Input[str]:
        return pulumi.get(self, "private_key_path")

    @private_key_path.setter
    def private_key_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "private_key_path", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="privateKeyPass")
    def private_key_pass(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "private_key_pass")

    @private_key_pass.setter
    def private_key_pass(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key_pass", value)

    @property
    @pulumi.getter
    def user(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "user")

    @user.setter
    def user(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user", value)


@pulumi.input_type
class ConnectionArgs:
    def __init__(__self__, *,
                 host: pulumi.Input[str],
                 private_key: pulumi.Input[str],
                 port: Optional[pulumi.Input[int]] = None,
                 private_key_pass: Optional[pulumi.Input[str]] = None,
                 user: Optional[pulumi.Input[str]] = None):
        pulumi.set(__self__, "host", host)
        pulumi.set(__self__, "private_key", private_key)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if private_key_pass is not None:
            pulumi.set(__self__, "private_key_pass", private_key_pass)
        if user is not None:
            pulumi.set(__self__, "user", user)

    @property
    @pulumi.getter
    def host(self) -> pulumi.Input[str]:
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: pulumi.Input[str]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter(name="privateKey")
    def private_key(self) -> pulumi.Input[str]:
        return pulumi.get(self, "private_key")

    @private_key.setter
    def private_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "private_key", value)

    @property
    @pulumi.getter
    def port(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "port")

    @port.setter
    def port(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "port", value)

    @property
    @pulumi.getter(name="privateKeyPass")
    def private_key_pass(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "private_key_pass")

    @private_key_pass.setter
    def private_key_pass(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "private_key_pass", value)

    @property
    @pulumi.getter
    def user(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "user")

    @user.setter
    def user(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user", value)


@pulumi.input_type
class DiskConfigArgs:
    def __init__(__self__, *,
                 hdds: pulumi.Input[Sequence[pulumi.Input['DiskArgs']]],
                 ssds: pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]):
        pulumi.set(__self__, "hdds", hdds)
        pulumi.set(__self__, "ssds", ssds)

    @property
    @pulumi.getter
    def hdds(self) -> pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]:
        return pulumi.get(self, "hdds")

    @hdds.setter
    def hdds(self, value: pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]):
        pulumi.set(self, "hdds", value)

    @property
    @pulumi.getter
    def ssds(self) -> pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]:
        return pulumi.get(self, "ssds")

    @ssds.setter
    def ssds(self, value: pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]):
        pulumi.set(self, "ssds", value)


@pulumi.input_type
class DiskSpecArgs:
    def __init__(__self__, *,
                 hdds: pulumi.Input[Sequence[pulumi.Input['DiskArgs']]],
                 ssds: pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]):
        pulumi.set(__self__, "hdds", hdds)
        pulumi.set(__self__, "ssds", ssds)

    @property
    @pulumi.getter
    def hdds(self) -> pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]:
        return pulumi.get(self, "hdds")

    @hdds.setter
    def hdds(self, value: pulumi.Input[Sequence[pulumi.Input['DiskArgs']]]):
        pulumi.set(self, "hdds", value)

    @property
    @pulumi.getter
    def ssds(self) -> pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]:
        return pulumi.get(self, "ssds")

    @ssds.setter
    def ssds(self, value: pulumi.Input[Sequence[pulumi.Input['SSDArgs']]]):
        pulumi.set(self, "ssds", value)


@pulumi.input_type
class DiskArgs:
    def __init__(__self__, *,
                 id: pulumi.Input[str]):
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[str]):
        pulumi.set(self, "id", value)


@pulumi.input_type
class NodeConfigArgs:
    def __init__(__self__, *,
                 disks: pulumi.Input['DiskConfigArgs'],
                 host: pulumi.Input[str],
                 connection: Optional[pulumi.Input['ConnectionConfigArgs']] = None):
        pulumi.set(__self__, "disks", disks)
        pulumi.set(__self__, "host", host)
        if connection is not None:
            pulumi.set(__self__, "connection", connection)

    @property
    @pulumi.getter
    def disks(self) -> pulumi.Input['DiskConfigArgs']:
        return pulumi.get(self, "disks")

    @disks.setter
    def disks(self, value: pulumi.Input['DiskConfigArgs']):
        pulumi.set(self, "disks", value)

    @property
    @pulumi.getter
    def host(self) -> pulumi.Input[str]:
        return pulumi.get(self, "host")

    @host.setter
    def host(self, value: pulumi.Input[str]):
        pulumi.set(self, "host", value)

    @property
    @pulumi.getter
    def connection(self) -> Optional[pulumi.Input['ConnectionConfigArgs']]:
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: Optional[pulumi.Input['ConnectionConfigArgs']]):
        pulumi.set(self, "connection", value)


@pulumi.input_type
class PartitionConfigArgs:
    def __init__(__self__, *,
                 db: pulumi.Input[str],
                 osd: pulumi.Input[str],
                 wal: pulumi.Input[str]):
        pulumi.set(__self__, "db", db)
        pulumi.set(__self__, "osd", osd)
        pulumi.set(__self__, "wal", wal)

    @property
    @pulumi.getter
    def db(self) -> pulumi.Input[str]:
        return pulumi.get(self, "db")

    @db.setter
    def db(self, value: pulumi.Input[str]):
        pulumi.set(self, "db", value)

    @property
    @pulumi.getter
    def osd(self) -> pulumi.Input[str]:
        return pulumi.get(self, "osd")

    @osd.setter
    def osd(self, value: pulumi.Input[str]):
        pulumi.set(self, "osd", value)

    @property
    @pulumi.getter
    def wal(self) -> pulumi.Input[str]:
        return pulumi.get(self, "wal")

    @wal.setter
    def wal(self, value: pulumi.Input[str]):
        pulumi.set(self, "wal", value)


@pulumi.input_type
class SSDArgs:
    def __init__(__self__, *,
                 id: pulumi.Input[str],
                 partitions: pulumi.Input['PartitionConfigArgs']):
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "partitions", partitions)

    @property
    @pulumi.getter
    def id(self) -> pulumi.Input[str]:
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: pulumi.Input[str]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def partitions(self) -> pulumi.Input['PartitionConfigArgs']:
        return pulumi.get(self, "partitions")

    @partitions.setter
    def partitions(self, value: pulumi.Input['PartitionConfigArgs']):
        pulumi.set(self, "partitions", value)


